-- CANARY FUNCTIONS

local Net = _G.LuaNetworking
local ban_global = CanaryOptions._data.ban_global
local ban_toggle = CanaryOptions._data.ban_toggle
local ban_pag_toggle = CanaryOptions._data.ban_pag_toggle
local ply_assault_toggle = CanaryOptions._data.ply_assault_toggle

if Net:IsMultiplayer() then
	if Net:IsHost() and not vr_hostcheck then
		vr_pager_no = 0
		vr_hostcheck = true
	end
elseif not Net:IsMultiplayer() and not vr_hostcheck then
	vr_pager_no = 0
	vr_hostcheck = true
end

if randomizer_t then
	max_ch = #randomizer_t
	if mercurius then
		ch_modified = #randomizer_t - ch_modify
	end
end

if ( file.DirectoryExists( "mods/HUDRestoration/" ) or file.DirectoryExists( "mods/HUDRESTORATION/" ) ) and not HUDRestorationExists then
	HUDRestorationExists = true
elseif ( not file.DirectoryExists( "mods/HUDRestoration/" ) or not file.DirectoryExists( "mods/HUDRESTORATION/" ) )  and not HUDRestorationExists then
	HUDRestorationExists = false
end

local pcheck = "C_PagerStatus"

Hooks:Add("NetworkReceivedData", "NetworkReceivedData_PagerResponse", function(sender, id, data)
    if id == pcheck then
	local p_data = tonumber(data)
	if ban_pag_toggle == true then
		if p_data < 3 then
			DelayedCalls:Add("v_pager_success", 2, vr_p_success)
		elseif p_data == 3 then
			DelayedCalls:Add("v_pager_suspicious", 2, vr_p_suspicious)
		elseif p_data == 4 then
			DelayedCalls:Add("v_pager_warning", 4, vr_p_warning)
		elseif p_data == 5 then
			DelayedCalls:Add("v_pager_failed", 1, vr_p_failed)
		end
	elseif ban_pag_toggle ~= true then
		local PagerRoll = math.random(1,100)
		if p_data == 1 then
			if PagerRoll == 1 then
				DelayedCalls:Add("v_pager_success", 2, vr_p_success)
			end
		elseif p_data == 2 then
			if PagerRoll <= 10 then
				DelayedCalls:Add("v_pager_success", 2, vr_p_success)
			end
		elseif p_data == 3 then
			if PagerRoll <= 50 then
				DelayedCalls:Add("v_pager_success", 2, vr_p_success)
			end
		elseif p_data == 4 then
			DelayedCalls:Add("v_pager_suspicious", 2, vr_p_suspicious)
		elseif p_data == 5 then
			DelayedCalls:Add("v_pager_failed", 1, vr_p_failed)
		end
	end
	end
end)

local hcheck = "C_CamHalf"

Hooks:Add("NetworkReceivedData", "NetworkReceivedData_CamHalf", function(sender, id, data)
	if not Net:IsHost() then
		if id == hcheck then
		if not ban_global then
		managers.player:local_player():sound():say( 'Play_ban_v02x', false, false )
		end
		end
	end
end)

local gcheck = "C_CamGone"

Hooks:Add("NetworkReceivedData", "NetworkReceivedData_CamGone", function(sender, id, data)
	if not Net:IsHost() then
		if id == gcheck then
		if not ban_global then
		managers.player:local_player():sound():say( 'Play_ban_v03x', false, false )
		end
		end
	end
end)

local ccheck = "C_Clock"

Hooks:Add("NetworkReceivedData", "NetworkReceivedData_Clock", function(sender, id, data)
	if not Net:IsHost() then
		if id == ccheck then
		if not ban_global then
			managers.dialog:queue_dialog( 'play_pln_gen_bfr_10', {})
		end
		end
	end
end)

vr_10s_i = vr_10s_i or function()
	if ( Utils:IsInCustody() ~= true ) then
	if not ban_global then
	managers.player:local_player():sound():say( 'Play_ban_b02b', false, ban_toggle )
	end
	DelayedCalls:Add("prep_10", 3, assault_prepare)
	end
end
vr_20s_i = vr_20s_i or function()
	if ( Utils:IsInCustody() ~= true ) then
	if not ban_global then
	managers.player:local_player():sound():say( 'Play_ban_b02a', false, ban_toggle )
	end
	DelayedCalls:Add("prep_20", 3, assault_20s)
	end
end
vr_10s_f = vr_10s_f or function()
	if ( Utils:IsInCustody() ~= true ) then
	if not ban_global then
	managers.player:local_player():sound():say( 'Play_ban_b05x', false, ban_toggle )
	end
	DelayedCalls:Add("prep_10", 3, assault_prepare)
	end
end
vr_20s_f = vr_20s_f or function()
	if ( Utils:IsInCustody() ~= true ) then
	if not ban_global then
	managers.player:local_player():sound():say( 'Play_ban_b04x', false, ban_toggle )
	end
	DelayedCalls:Add("prep_20_FUCK", 1, assault_20s_f)
	end
end
--
vr_b_success = vr_b_success or function()
if not ban_global then
	managers.dialog:queue_dialog('Play_ban_g02x', {})
end
end
vr_b_failed = vr_b_failed or function()
if not ban_global then
	managers.dialog:queue_dialog('Play_ban_g01x', {})
end
end
vr_c_suspicious = vr_c_suspicious or function()
	if Utils:IsInCustody() ~= true then
	if not ban_global then
	managers.player:local_player():sound():say( 'Play_ban_b01a', false, ban_toggle )
	end
	end
end
vr_c_alert = vr_c_alert or function()
	if Utils:IsInCustody() ~= true then
	if not ban_global then
	managers.player:local_player():sound():say( 'pln_alm_cam_rob', false, ban_toggle )
	end
	end
end
vr_c_first = vr_c_first or function()
	if not vr_cam_notifier_1 then
	if not ban_global then
	managers.player:local_player():sound():say( 'Play_ban_v01a', false, ban_toggle )
	end
	vr_cam_notifier_1 = true
	end
end
vr_p_notify = vr_p_notify or function()
if Utils:IsInCustody() ~= true then
if not ban_global then
	managers.player:local_player():sound():say( 'Play_pln_pager_a', false, ban_toggle )
end
end
end
vr_p_warning = vr_p_warning or function()
if not ban_global then
	managers.player:local_player():sound():say( 'Play_pln_pat_05', false, ban_toggle )
end
end
vr_p_break = vr_p_break or function()
if not ban_global then
	managers.player:local_player():sound():say( 'Play_pln_radio_break', false, ban_toggle )
end
end
vr_p_success = vr_p_success or function()
if not ban_global then
	managers.player:local_player():sound():say( 'Play_pln_radio_success', false, ban_toggle )
end
end
vr_p_missed = vr_p_missed or function()
if not ban_global then
	managers.player:local_player():sound():say( 'Play_pln_radio_missed', false, ban_toggle )
end
end
vr_p_suspicious = vr_p_suspicious or function()
if not ban_global then
	managers.player:local_player():sound():say( 'Play_pln_pat_04', false, ban_toggle )
end
end
vr_p_failed = vr_p_failed or function()
if not ban_global then
	managers.player:local_player():sound():say( 'Play_pln_radio_failed', false, ban_toggle )
end
end
vr_flashbang_alert = vr_flashbang_alert or function()
	if Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( 'g41x_any', true, true )
	end
end
vr_flashbang_check_2 = vr_flashbang_check_2 or function()
	vr_flashbang_check = nil
end
vr_trade_potential = vr_trade_potential or function()
	if Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( 'p07', true, true )
	end
end
vr_noreturn_delay = vr_noreturn_delay or function()
	if Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( 'g17', false, false ) -- Houston
	end
end
vr_noreturn_fifteen = vr_noreturn_fifteen or function()
	if Utils:IsInCustody() ~= true then
	if not ban_global then
	managers.player:local_player():sound():say( 'Play_ban_p01', false, ban_toggle )
	end
	end
end
vr_noreturn_thirty = vr_noreturn_thirty or function()
	if Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( 'p19', false, true )
	end
end
vr_noreturn_45 = vr_noreturn_45 or function()
	if Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( 'p04', false, false )
	end
end
vr_noreturn_55 = vr_noreturn_55 or function()
	if Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( 'g29', false, false )
	end
end
vr_letsrock = vr_letsrock or function()
	if Utils:IsInGameState() and Utils:IsInHeist() then
	local vr_letsrock = { 'g16', 'a01x_any', 'g18', 'g90' }
	letsrock = letsrock + 1
	if letsrock == 1 then
	managers.player:local_player():sound():say( 'a01x_any', false, false )
	elseif letsrock > 1 then
	managers.player:local_player():sound_source():set_switch("int_ext", "third")
	managers.player:local_player():sound():say( vr_letsrock[math.random( #vr_letsrock )], false, false )
	managers.player:local_player():sound_source():set_switch("int_ext", "first")
	end
	end
end
vr_warcry_check = vr_warcry_check or function()
if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
vr_wc_check = nil
	if not vr_wc_check and not vr_stop then
	vr_wc_check = true
	DelayedCalls:Add("warcry_rep", 0, vr_warcry_rep)
	end
end
end
vr_warcry = vr_warcry or function()
local cs = managers.player._current_state
	if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	if (cs ~= "bleed_out") or (cs ~= "incapacitated") or (cs ~= "arrested") or (cs ~= "tased") then
	managers.player:local_player():sound_source():set_switch("int_ext", "third")
	managers.player:local_player():sound():say( "g90", false, true )
	managers.player:local_player():sound_source():set_switch("int_ext", "first")
	end
	if not vr_stop then
	DelayedCalls:Add("warcry_check", 0, vr_warcry_check)
	end
	end
end
vr_warcry_rep = vr_warcry_rep or function()
	local time_warcry = {25, 30, 35, 40, 45, 55, 60, 65, 75, 80, 85, 90, 95 }
	local time_random = time_warcry[math.random( #time_warcry )]
	if not vr_stop then
	--log(tostring(time_random), "until the next war cry", "\n")
	DelayedCalls:Add("warcry", time_random, vr_warcry)
	end
end
assault_30s = assault_30s or function()
	if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( "g62", false, ply_assault_toggle )
	end
end
assault_20s = assault_20s or function()
	if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	managers.player:local_player():sound_source():set_switch("int_ext", "third")
	managers.player:local_player():sound():say( "g70", false, ply_assault_toggle )
	managers.player:local_player():sound_source():set_switch("int_ext", "first")
	end
end
assault_20s_f = assault_20s_f or function()
	if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	managers.player:local_player():sound_source():set_switch("int_ext", "third")
	managers.player:local_player():sound():say( "r01x_sin", false, ply_assault_toggle )
	managers.player:local_player():sound_source():set_switch("int_ext", "first")
	end
end
assault_prepare = assault_prepare or function()
	if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	managers.player:local_player():sound_source():set_switch("int_ext", "third")
	managers.player:local_player():sound():say( "g50", false, ply_assault_toggle )
	managers.player:local_player():sound_source():set_switch("int_ext", "first")
	end
end
vr_inbound = vr_inbound or function()
	if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	managers.dialog:queue_dialog( "Play_ban_s05", {} )
	end
end
rev_clbk = rev_clbk or function()
	vr_revive = nil
end
tie_clbk = tie_clbk or function()
	cableties_first = true
end
incoming_clk = incoming_clk or function()
	if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	if not ban_global then
	managers.player:local_player():sound():say( "Play_ban_s04", false, ban_toggle )
	end
	end
end
incoming_tsr = incoming_tsr or function()
	managers.player:local_player():sound():say( "Play_ban_s01_a", false, ban_toggle )
end
incoming_tsr_g = incoming_tsr_g or function()
	managers.player:local_player():sound():say( "Play_ban_s01_b", false, ban_toggle )
end
incoming_shd = incoming_shd or function()
	managers.player:local_player():sound():say( "Play_ban_s03_a", false, ban_toggle )
end
incoming_shd_g = incoming_shd_g or function()
	managers.player:local_player():sound():say( "Play_ban_s03_b", false, ban_toggle )
end
incoming_bdz = incoming_bdz or function()
	managers.player:local_player():sound():say( "Play_ban_s02_a", false, ban_toggle )
end
incoming_bdz_g = incoming_bdz_g or function()
	managers.player:local_player():sound():say( "Play_ban_s02_b", false, ban_toggle )
end
camera_upd = camera_upd or function()
	vr_fetch_count = true
	vr_camera_halfway = vr_camera_count / 2
end
drill_place = drill_place or function()
if vr_drill_place and managers.player:player_unit():movement():current_state():_interacting() then
	managers.player:local_player():sound():say( 'g21', true, true )
end
end
lance_place = lance_place or function()
if vr_drill_place and managers.player:player_unit():movement():current_state():_interacting() then
	managers.player:local_player():sound():say( 't01x_sin', true, true )
end
end
tape_cmon = tape_cmon or function()
if vr_tapeloop and managers.player:player_unit():movement():current_state():_interacting() then
	managers.player:local_player():sound():say( 'p04', true, true )
end
end
tape_move = tape_move or function()
if vr_tapeloop and managers.player:player_unit():movement():current_state():_interacting() then
	managers.player:local_player():sound():say( 'g18', true, true )
end
end
wd1_warn = wd1_warn or function()
	managers.player:local_player():sound():say( "Play_rb4_watchdogs_stage1_04", false, true )
end
wd1_fire = wd1_fire or function()
	managers.player:local_player():sound():say( "g23", false, true )
end
dia_bank_gas = dia_bank_gas or function()
if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( "g42x_any", false, true )
end
end
stealing_bags = stealing_bags or function()
if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( "p31", false, true )
end
end
holyshit = holyshit or function()
if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
local vr_character = managers.criminals:local_character_name()
	if vr_character == "american" then
	managers.player:local_player():sound():say( "g29", false, true )
	else
	managers.player:local_player():sound():say( "g60", false, true )
	end
end
end
gotemall = gotemall or function()
if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
local current_map = managers.job:current_level_id()
	if current_map == "jewelry_store" or current_map == "ukrainian_job" then
	managers.player:local_player():sound():say( "Play_rbr_knk_jwl_b_dia_71", false, true )
	else
	managers.player:local_player():sound():say( "p28", false, true )
	end
end
end
halfwaygot = halfwaygot or function()
if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( "t02x_sin", false, true )
end
end
pln_jwl_04 = pln_jwl_04 or function()
	managers.dialog:queue_dialog("pln_jwl_04", {})
end
sniper_call = sniper_call or function()
if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( "f34x_any", false, false )
end	
end
rat_forest = rat_forest or function()
if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( "p44", false, false )
end
end
rat_window = rat_window or function()
if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( "p36", false, false )
end
end
rat_stairwell = rat_stairwell or function()
if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( "g02", false, false )
end
end
rat_inside = rat_inside or function()
if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( "g08", false, false )
end
end
rat_balcony = rat_balcony or function()
if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( "p35", false, false )
end
end
pln_rt_07 = pln_rt_07 or function()
if Utils:IsInGameState() and Utils:IsInHeist() then
	managers.dialog:queue_dialog( 'pln_rt1_07', {})
end
end
pl_inside = pl_inside or function()
if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( "g16", false, false )
end
end
pl_outside = pl_outside or function()
if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( "p38", false, false )
end
end
pl_roofs = pl_roofs or function()
if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( "p34", false, false )
end
end
pl_down = pl_down or function()
if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( "p37", false, false )
end
end
snip_climbup = snip_climbup or function()
if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( "p40", false, false )
end
end
snip_heli = snip_heli or function()
if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( "p41", false, false )
end
end
pln_rt_30 = pln_rt_30 or function()
if Utils:IsInGameState() and Utils:IsInHeist() then
	managers.dialog:queue_dialog( 'pln_rat_stage1_30', {})
end
end
bain_risks = bain_risks or function()
if not bain_global then
	managers.dialog:queue_dialog( 'play_pln_gen_bfr_12', {})
end
end
lingering = lingering or function()
if not bain_global then
	if linger and not managers.groupai:state():whisper_mode() then
	managers.dialog:queue_dialog( 'play_pln_gen_bfr_09', {})
	end
end
end
pln_rt_31 = pln_rt_31 or function()
if Utils:IsInGameState() and Utils:IsInHeist() then
	managers.dialog:queue_dialog( 'pln_rat_stage1_31', {})
end
end
esc_230 = esc_230 or function()
if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( "g66", false, false )
end
end
esc_200 = esc_200 or function()
if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( "g65", false, false )
end
end
esc_100 = esc_100 or function()
if Utils:IsInGameState() and Utils:IsInHeist() and Utils:IsInCustody() ~= true then
	managers.player:local_player():sound():say( "g63", false, false )
end
end
stopforabit = stopforabit or function()
	stopforabitv = nil
end
--
said_hurt = said_hurt or function()
vr_said_hurt = nil
end
r_fixmeup = r_fixmeup or function()
vr_fixmeup = nil
end
vr_outties = vr_outties or function()
	managers.player:local_player():sound():say( "s32x_sin", true, false )
end
randomize_dc = randomize_dc or function()
end
mercurius_exec = mercurius_exec or function()
end