_G.CanaryOptions = _G.CanaryOptions or {}
CanaryOptions._path = ModPath
CanaryOptions._data_path = SavePath .. "canary_data.txt"
CanaryOptions._data = {} 

function CanaryOptions:Save()
	local file = io.open( self._data_path, "w+" )
	if file then
		file:write( json.encode( self._data ) )
		file:close()
	end
end

function CanaryOptions:Load()
	local file = io.open( self._data_path, "r" )
	if file then
		self._data = json.decode( file:read("*all") )
		file:close()
	end
end

Hooks:Add("LocalizationManagerPostInit", "LocalizationManagerPostInit_CanaryOptions", function( loc )
	loc:load_localization_file( CanaryOptions._path .. "Menu/en.txt")
end)

Hooks:Add( "MenuManagerInitialize", "MenuManagerInitialize_CanaryOptions", function( menu_manager )

	MenuCallbackHandler.callback_bain_tog_glo = function(self, item)
		CanaryOptions._data.ban_global = (item:value() == "on" and true or false)
		CanaryOptions:Save()
		log("bain is: " .. item:value())
	end
	MenuCallbackHandler.callback_bain_tog = function(self, item)
		CanaryOptions._data.ban_toggle = (item:value() == "on" and true or false)
		CanaryOptions:Save()
		log("bain's voice is: " .. item:value())
	end
	MenuCallbackHandler.callback_bain_pag_tog = function(self, item)
		CanaryOptions._data.ban_pag_toggle = (item:value() == "on" and true or false)
		CanaryOptions:Save()
		log("bain_pag is: " .. item:value())
	end
	MenuCallbackHandler.callback_ply_assault_tog = function(self, item)
		CanaryOptions._data.ply_assault_toggle = (item:value() == "on" and true or false)
		CanaryOptions:Save()
		log("ply_assault is: " .. item:value())
	end
	MenuCallbackHandler.callback_ply_knees_tog = function(self, item)
		CanaryOptions._data.ply_knees_toggle = (item:value() == "on" and true or false)
		CanaryOptions:Save()
		log("ply_knees is: " .. item:value())
	end
	MenuCallbackHandler.callback_ply_cams_tog = function(self, item)
		CanaryOptions._data.ply_cams_toggle = (item:value() == "on" and true or false)
		CanaryOptions:Save()
		log("ply_cams is: " .. item:value())
	end
	MenuCallbackHandler.callback_ban_h_success_tog = function(self, item)
		CanaryOptions._data.ban_h_success_toggle = (item:value() == "on" and true or false)
		CanaryOptions:Save()
		log("ban_hsuccess is: " .. item:value())
	end
	MenuCallbackHandler.callback_ban_h_failure_tog = function(self, item)
		CanaryOptions._data.ban_h_failure_toggle = (item:value() == "on" and true or false)
		CanaryOptions:Save()
		log("ban_hfailure is: " .. item:value())
	end
	
	
	MenuCallbackHandler.callback_test_multi = function(self, item)
		CanaryOptions._data.multi_value = item:value()
		CanaryOptions:Save()
		log("Multiple-choice value: " .. item:value())
	end

	CanaryOptions:Load()

	MenuHelper:LoadFromJsonFile( CanaryOptions._path .. "Menu/canary_menu.txt", CanaryOptions, CanaryOptions._data )

end )
